SHEBANG
# Copyright (C) @BABOLO  2009 http://www.babolo.ru/
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: addon.m4,v 1.1 2009/10/10 00:28:13 babolo Exp $

Ls="bcmath     \
    bz2        \
    calendar   \
    ctype      \
    curl       \
    dba        \
    dbase      \
    dom        \
    exif       \
    fileinfo   \
    filter     \
    fribidi    \
    ftp        \
    gd         \
    gettext    \
    gmp        \
    hash       \
    iconv      \
    imap       \
    interbase  \
    json       \
    ldap       \
    mbstring   \
    mcrypt     \
    mhash      \
    ming       \
    mssql      \
    mysql      \
    mysqli     \
    ncurses    \
    odbc       \
    openssl    \
    pcntl      \
    pcre       \
    pdf        \
    pdo        \
    pdo_sqlite \
    pgsql      \
    posix      \
    pspell     \
    readline   \
    recode     \
    session    \
    shmop      \
    simplexml  \
    snmp       \
    soap       \
    sockets    \
    spl        \
    sqlite     \
    sybase_ct  \
    sysvmsg    \
    sysvsem    \
    sysvshm    \
    tidy       \
    tokenizer  \
    wddx       \
    xml        \
    xmlreader  \
    xmlrpc     \
    xmlwriter  \
    xsl        \
    yaz        \
    zip        \
    zlib       \
"
extdir="${PREFIX}/lib/php/20060613-debug"
. ${JAILUP_CONF}
list=

for i in ${Ls}; do
    if  ${grep} -qE "^extension=${i}.so"'$' "${PREFIX}/etc/php/extensions.ini"; then
        if  [ -f "${extdir}/${i}.so" ]; then
            list="${list} ${i}"
    fi; fi
done

JNTROSTUP(apache,,apache-php-5dnl
,dnl
# jailup ${inclass} <dir> <ext ...>
#     where dir relative to ${JAILRODIR}
#     possible extensions are: ${list}
# installed ports/lang/php5 and ports/lang/php5-extensions useddnl
,TESTADMINdnl
)

jdir="${1}"
shift
main_dir="${JAILUPDIR}/${jdir}"
conf_dir="${JAILRODIR}/${jdir}"
t0=`${mktemp} -t jailup`
t1=`${mktemp} -t jailup`
t2=`${mktemp} -t jailup`

${mkdir} "${main_dir}" "${conf_dir}/php"
${up_mdir} "${main_dir}" "${MTREE}"
${up_genlist} libexec/ "${MTREE}" | ${up_libexe} "${main_dir}/libexec" "${PREFIX}/libexec/apache22"
${up_genlist} lib/ "${MTREE}" | ${up_shlib} "${main_dir}/lib"

for i in "$@"; do
    j=
    for k in ${list}; do
        if  [ x"${i}" = x"${k}" ]; then
            j="${i}"
        fi
    done
    if  [ x"${j}" = x ]; then
        ech="${ech}!!!WARNING!!! extension ${i} does not found ******
"
    else
        echo "${i}.so" | ${up_shlib} "${main_dir}/libexec/php" "${extdir}"
        echo "${main_dir}/libexec/php/${i}.so" | ${up_ldsh} | ${up_shlib} "${main_dir}/lib"
        echo "extension=${i}.so" | ${up_adc} "${conf_dir}/php/extensions.ini"
        echo "${i}.so" >> "${t2}"

        ${ldd} "${main_dir}/libexec/php/${i}.so"\
      | ${awk} -v ext="${i}" -v t1="${t1}" '/^	/{print $1 >>t1}' /dev/stdin
    fi
done

  ${sort} -u "${t1}"  \
| ${awk} -v t2="${t2}"\
    'BEGIN{
         b = 0;
         c = 0;
     }
     {   d = 0;}
     (FILENAME == t2){
         d = 1;
         p[b++] = $0;
     }
     (FILENAME == "/dev/stdin"){
         d = 2;
         l[c++] = $0;
     }
     !(d) && /COMMAND/{
         d = 3;
         for (i = 0; i < b; i++) {
             print "            " p[i];
     }   }
     !(d) && /LIBRARIES/{
         d = 4;
         for (i = 0; i < c; i++) {
             print "        " l[i];
     }   }
     !(d){
         print $0;
     }'       \
    /dev/stdin\
    "${t2}"   \
    ${MTREE}  \
> "${t0}"

CONFCOPY(php.ini,  "${TEMPLATE}")

      #####################################
      ####                             ####
      #### Begin of etc fill           ####
      ####                             ####
${up_adc} "${etcdir}/newsyslog.conf" <<- EOF
	#${main_dir}/var/log/php 	644  9     *	@01T00
EOF
      ####                             ####
      #### End of etc fill             ####
      ####                             ####
      #####################################

${mtree} -Ueqxp "${main_dir}" -f "${t0}"
${mtree} -Ueqxp "${conf_dir}" <<- "EOF"
/set type=dir uname=root gname=wheel mode=0755 flags=none
	.
	    php
	/set type=file mode=0644
	        extensions.ini
	    ..
	    php.ini
	..
EOF

${rm} -f "${t0}" "${t1}" "${t2}"
echo -n "${ech}"

for i in `${sed} -e 's|^extension=||' -e 's|\.so$||' "${conf_dir}/php/extensions.ini"`; do
    j=
    for k in "$@"; do
        if  [ x"${i}" = x"${k}" ]; then
            j="${i}"
        fi
    done
    if  [ x"${j}" = x ]; then
        echo "!!!WARNING!!! extension ${i} not requested but installed before ******"
    fi
done
